import { ComponentType } from 'react';
export type LoadComponentFn<P = Record<string, any>> = () => Promise<ComponentType<P>>;
export type LoadableMixin = {
    preload(): void;
};
export type LoadableComponent<P = Record<string, any>> = ComponentType<P> & LoadableMixin;
export interface LoadableConfig {
    loader?: ComponentType<any>;
    /**
     * Component which renders with the lazy component
     */
    extra?: ComponentType<any>;
}
type LoadableComponent$<P> = LoadableComponent<P>;
export declare function loadable<P = any>(loadFn: LoadComponentFn<P>, loaderOrConfig?: null | undefined | LoadableConfig['loader'] | LoadableConfig): LoadableComponent$<P>;
export {};
//# sourceMappingURL=loadable.d.ts.map